window.Gleam.initSearch([{"doc":"ids","title":"ids","content":"# ids\n\n![CI](https://github.com/lrosa007/ids/workflows/test/badge.svg?branch=main)\n[![Package Version](https://img.shields.io/hexpm/v/ids)](https://hex.pm/packages/ids)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/ids/)\n\n✨ Unique IDs for Gleam\n\n## Supported\n\n- [CUID](https://github.com/ericelliott/cuid)\n- [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier)\n- [NanoID](https://github.com/ai/nanoid)\n\n## Installation\n\nThe library is available on Hex so it can be added to your Gleam project by simply running:\n\n```sh\ngleam add ids\n```\n\n## References\n\n1. [Original CUID](https://en.wikipedia.org/wiki/Universally_unique_identifier)\n2. [Elixir CUID](https://github.com/duailibe/cuid)\n3. [Ecto UUID](https://github.com/elixir-ecto/ecto/blob/v3.5.4/lib/ecto/uuid.ex)\n","url":"index.html"},{"doc":"ids/cuid","title":"Message","content":"pub opaque type Message\n The messages handled by the actor.\n\n The actor shouldn&#39;t be called directly so this type is opaque.\n\nSynonyms:\nids/cuid.Message\nids/cuid Message","url":"ids/cuid.html#Message"},{"doc":"ids/cuid","title":"State","content":"pub opaque type State\n The internal state of the actor.\n\n The state keeps track of a counter and a fingerprint.\n Both are used when generating a CUID.\n\nSynonyms:\nids/cuid.State\nids/cuid State","url":"ids/cuid.html#State"},{"doc":"ids/cuid","title":"generate","content":"pub fn generate(channel: Subject(Message)) -&gt; String\n Generates a CUID using the given channel.\n\n ### Usage\n \n import ids/cuid\n\n let assert Ok(channel) = cuid.start()\n\n let id: String = cuid.generate(channel)\n\n let slug: String = cuid.slug(channel)\n \nSynonyms:\nids/cuid.generate\nids/cuid generate","url":"ids/cuid.html#generate"},{"doc":"ids/cuid","title":"is_cuid","content":"pub fn is_cuid(id: String) -&gt; Bool\n Checks if a string is a CUID.\nSynonyms:\nids/cuid.is_cuid\nids/cuid is_cuid","url":"ids/cuid.html#is_cuid"},{"doc":"ids/cuid","title":"is_slug","content":"pub fn is_slug(slug: String) -&gt; Bool\n Checks if a string is a slug.\nSynonyms:\nids/cuid.is_slug\nids/cuid is_slug","url":"ids/cuid.html#is_slug"},{"doc":"ids/cuid","title":"slug","content":"pub fn slug(channel: Subject(Message)) -&gt; String\n Generates a slug using the given channel.\nSynonyms:\nids/cuid.slug\nids/cuid slug","url":"ids/cuid.html#slug"},{"doc":"ids/cuid","title":"start","content":"pub fn start() -&gt; Result(Subject(Message), StartError)\n Starts a CUID generator.\nSynonyms:\nids/cuid.start\nids/cuid start","url":"ids/cuid.html#start"},{"doc":"ids/cuid","title":"ids/cuid","content":" A module for generating CUIDs (Collision-resistant Unique Identifiers).\n The implementation requires a counter, so an actor is used to keep track\n of that state. This means before generating a CUID, an actor needs to be\n started and all work is done via a channel.\n\n Slugs are also supported.\n","url":"ids/cuid.html"},{"doc":"ids/uuid","title":"generate_v4","content":"pub fn generate_v4() -&gt; Result(String, String)\n Generates a version 4 (random) UUID. The version 4 UUID produced\n by this function is generated using a cryptographically secure \n random number generator.\n\n ### Usage\n \n import ids/uuid\n\n let assert Ok(id) = uuid.generate_v4()\n \n\nSynonyms:\nids/uuid.generate_v4\nids/uuid generate_v4","url":"ids/uuid.html#generate_v4"},{"doc":"ids/uuid","title":"ids/uuid","content":" A module for generating UUIDs (Universally Unique Identifiers).\n\n The module currently supports UUID versions:\n - Version 4 (random)\n","url":"ids/uuid.html"},{"doc":"ids/nanoid","title":"default_alphabet","content":"pub const default_alphabet: BitString = &lt;&lt;\n  &quot;_-0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ&quot;:utf8,\n&gt;&gt;\n The default alphabet used when generating NanoIDs.\nSynonyms:\nids/nanoid.default_alphabet\nids/nanoid default_alphabet","url":"ids/nanoid.html#default_alphabet"},{"doc":"ids/nanoid","title":"default_size","content":"pub const default_size: Int = 21\n The default size of the generated NanoIDs. \nSynonyms:\nids/nanoid.default_size\nids/nanoid default_size","url":"ids/nanoid.html#default_size"},{"doc":"ids/nanoid","title":"generate","content":"pub fn generate() -&gt; Result(String, String)\n Generates a (random) NanoID. The NanoID produced by this function is \n generated using a cryptographically secure random number generator.\n\n ### Usage\n \n import ids/nanoid\n\n let assert Ok(id) = nanoid.generate()\n \n\nSynonyms:\nids/nanoid.generate\nids/nanoid generate","url":"ids/nanoid.html#generate"},{"doc":"ids/nanoid","title":"ids/nanoid","content":" A module for generating NanoIDs, i.e., tiny, secure, URL-friendly, \n and unique string IDs.\n","url":"ids/nanoid.html"}]);